Bug 832466 - filter() function broken
filter() function broken
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: octave (Show other bugs)
16
i686 Linux
unspecified Severity low
: ---
: ---
Assigned To: Jaromír Cápík
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-15 09:11 EDT by Henry Leinhos
Modified: 2016-01-31 20:56 EST (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-12 18:24:34 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Henry Leinhos 2012-06-15 09:11:08 EDT
Description of problem:

filtfilt() function returns an error:
error: filter: first dimension of SI must be of length max (length (a), length (b)) - 1
error: called from:
error:   /usr/share/octave/packages/signal-1.0.11/filtfilt.m at line 85, column 3


Version-Release number of selected component (if applicable):

octave-signal-1.0.11-2.fc16.i686

How reproducible:
Every time

Steps to Reproduce:

1. Run the example from the help text for filtfilt():

>> help filtfilt
`filtfilt' is a function from the file /usr/share/octave/packages/signal-1.0.11/filtfilt.m

 usage: y = filtfilt(b, a, x)

 Forward and reverse filter the signal. This corrects for phase
 distortion introduced by a one-pass filter, though it does square the
 magnitude response in the process. That's the theory at least.  In
 practice the phase correction is not perfect, and magnitude response
 is distorted, particularly in the stop band.

 Example
    [b, a]=butter(3, 0.1);                   % 10 Hz low-pass filter
    t = 0:0.01:1.0;                         % 1 second sample
    x=sin(2*pi*t*2.3)+0.25*randn(size(t));  % 2.3 Hz sinusoid+noise
    y = filtfilt(b,a,x); z = filter(b,a,x); % apply filter
    plot(t,x,';data;',t,y,';filtfilt;',t,z,';filter;')

>>    [b, a]=butter(3, 0.1);                   % 10 Hz low-pass filter
>>    t = 0:0.01:1.0;                         % 1 second sample
>>    x=sin(2*pi*t*2.3)+0.25*randn(size(t));  % 2.3 Hz sinusoid+noise
>>    y = filtfilt(b,a,x);
error: filter: first dimension of SI must be of length max (length (a), length (b)) - 1
error: called from:
error:   /usr/share/octave/packages/signal-1.0.11/filtfilt.m at line 85, column 3
>> 

 
Additional info:

There was an earlier bug in filter() using state input, but was fixed upstream. This looks familiar...
Comment 1 Henry Leinhos 2012-06-15 10:50:36 EDT
After looking closer, filter() seems to be the problem:

>> b = ones(5,1)/5;
>> a = 1;
>> [y0 SF] = filter(b,a,1)
       y0 =  0.20000
        SF =

          0.20000
          0.20000
          0.20000
          0.20000

>> [y1 SF] = filter(b,a,1,SF);

error: filter: first dimension of SI must be of length max (length (a), length (b)) - 1

But:

>> max (length (a), length (b)) - 1   
     ans =  4


This was a problem in earlier versions of octave-signal, but was fixed upstream.
Comment 2 Henry Leinhos 2012-06-15 11:03:17 EDT
This is a duplicate of bug 820791 (sorry!)

https://bugzilla.redhat.com/show_bug.cgi?id=820791

Which states it's fixed in Fedora 17, but Fedora 16 has not been updated yet.

Will F16 be updated?
Comment 3 Thomas Sailer 2012-06-17 13:58:23 EDT
Thanks for the investigation. Since filter is part of the octave base package, I'm changing the component of the bug report
Comment 4 Orion Poplawski 2012-06-19 12:07:56 EDT
It is unlikely that octave will be updated in Fedora 16 to the F17 version.  If someone wants to track down the patch to fix this bug and backport to the F16 version we could issue a fix that way.
Comment 5 Henry Leinhos 2012-06-20 09:16:57 EDT
The F17 octave srpm compiles under F16 without modification, is there any reason why F16 can't be updated?
Comment 6 Susi Lehtola 2012-06-20 09:33:58 EDT
It's part of the updates policy.
http://fedoraproject.org/wiki/Updates_Policy#Philosophy
Comment 7 Orion Poplawski 2012-06-20 09:45:41 EDT
There are api/abi changes.  Everything that requires octave would need to be recompiled.  If you need a newer octave, upgrade to Fedora 17.
Comment 8 Fedora End Of Life 2013-01-16 12:06:35 EST
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 9 Fedora Admin XMLRPC Client 2013-01-29 10:27:48 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 10 Fedora End Of Life 2013-02-13 09:55:25 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.